---
title: Symbol.hasInstance
slug: Web/JavaScript/Reference/Global_Objects/Symbol/hasInstance
tags:
  - ECMAScript 2015
  - JavaScript
  - Property
  - Reference
  - Symbol
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>Symbol.hasInstance</code></strong> well-known symbol is used to determine if a constructor object recognizes an object as its instance. The {{jsxref("Operators/instanceof", "instanceof")}} operator's behavior can be customized by this symbol.</span></p>

<div>{{EmbedInteractiveExample("pages/js/symbol-hasinstance.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div>{{js_property_attributes(0,0,0)}}</div>

<h2 id="Examples">Examples</h2>

<h3 id="Custom_instanceof_behavior">Custom instanceof behavior</h3>

<p>You could implement your custom <code>instanceof</code> behavior like this, for example:</p>

<pre class="brush: js notranslate">class MyArray {
  static [Symbol.hasInstance](instance) {
    return Array.isArray(instance)
  }
}
console.log([] instanceof MyArray); // true
</pre>

<pre class="brush: js notranslate">function MyArray() { }
Object.defineProperty(MyArray, Symbol.hasInstance, {
  value: function(instance) { return Array.isArray(instance); }
});
console.log([] instanceof MyArray); // true</pre>

<h3 id="Checking_the_instance_of_an_object">Checking the instance of an object</h3>

<p>Just in the same manner at which you can check if an object is an instance of a  class using the <code>instanceof</code> keyword, we can also use <code>Symbol.hasInstance</code> for such checks also.</p>

<pre class="brush: js notranslate">class Animal {
  constructor() {}
}

const cat = new Animal();

console.log(Animal[Symbol.hasInstance](cat)); // true
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.hasinstance', 'Symbol.hasInstance')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.hasInstance")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Operators/instanceof", "instanceof")}}</li>
</ul>
